package mine.testprojects.com;

import android.app.ActionBar;
import android.app.ActionBar.TabListener;
import android.app.FragmentTransaction;
import android.app.ActionBar.Tab;
import android.app.Activity;
import android.content.Context;
import android.graphics.YuvImage;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View.OnHoverListener;
import android.widget.Toast;

public class TestActionBarActivity extends Activity 
{
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        ActionBar myActionBar = getActionBar();
        
        // To enable the icon for up navigation (which displays the "up" indicator next to the icon),
        //myActionBar.setDisplayHomeAsUpEnabled(true);
        
        
        // Not working without the following line
        myActionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);//working. No need to set in the main.xml in graphical layout view the device to tablet, or neither modifying the AVD 
        //myActionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_LIST);// List shown but no tabs appear
        //myActionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_STANDARD);//Not working. This is the normal phone view not tablet, so tabbed navigation is not hanlded
        
        Tab tab1 = myActionBar.newTab();
        
        //myActionBar.setBackgroundDrawable(getWallpaper());
        //myActionBar.set
        tab1.setText("First Tab");// Appears capital! It seems API 15 issue
        //tab1.setText(R.string.tab1_string);// Also capital
        //tab1.setText(getResources().getString(R.string.tab1_string));// Also capital
        
        // Working
//        tab1.setTabListener(new ActionBar.TabListener()
//        {
//			private void OnHoverListener() 
//			{
//				// TODO Auto-generated method stub
//
//			}
//			@Override
//			public void onTabUnselected(Tab tab, FragmentTransaction ft) 
//			{
//				// TODO Auto-generated method stub
//				
//			}
//			
//			@Override
//			public void onTabSelected(Tab tab, FragmentTransaction ft)
//			{
//				// TODO Auto-generated method stub
//				showMsg(tab.getPosition());
//				//Toast.makeText(, "Tab " + tab.getPosition() + "Selected", Toast.LENGTH_SHORT).show();
//				
//			}
//			
//			@Override
//			public void onTabReselected(Tab tab, FragmentTransaction ft) {
//				// TODO Auto-generated method stub
//				
//			}
//		});
        
        // To set the context
        tab1.setTabListener(new MyTabListener(this));
        
        
        Tab tab2 = myActionBar.newTab();
        tab2.setText("Second Tab");
        
        
        tab2.setTabListener(new ActionBar.TabListener()
        {
			
			@Override
			public void onTabUnselected(Tab tab, FragmentTransaction ft) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onTabSelected(Tab tab, FragmentTransaction ft) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onTabReselected(Tab tab, FragmentTransaction ft) {
				// TODO Auto-generated method stub
				
			}
		});
        
        
        myActionBar.addTab(tab1);
        myActionBar.addTab(tab2);
        myActionBar.selectTab(tab2);
        
    }
    
    public class MyTabListener implements TabListener
    {
    	private Context context;
    	MyTabListener(Context context)
    	{
    		this.context = context;
    	}

    	// Not working
		private void OnHoverListener() 
		{
			// TODO Auto-generated method stub
			Toast.makeText(this.context, "Hover", Toast.LENGTH_SHORT).show();

		}
    	
		// Working
		@Override
		public void onTabReselected(Tab tab, FragmentTransaction ft)
		{
			// TODO Auto-generated method stub
			Toast.makeText(this.context, tab.getText() + " Selected again", Toast.LENGTH_SHORT).show();
			
		}

		// Working
		@Override
		public void onTabSelected(Tab tab, FragmentTransaction ft)
		{
			// TODO Auto-generated method stub
			//Toast.makeText(this.context, "Tab " + tab.getPosition() + " Selected", Toast.LENGTH_SHORT).show();
			Toast.makeText(this.context, tab.getText() + " Selected", Toast.LENGTH_SHORT).show();
			
			
		}

		// Working if another tab selected after current is selected
		@Override
		public void onTabUnselected(Tab tab, FragmentTransaction ft) 
		{
			// TODO Auto-generated method stub
			Toast.makeText(this.context, tab.getText() + " Unselected", Toast.LENGTH_SHORT).show();
			
		}
    	
    };
    private void showMsg(String msg)
    {
    	Toast.makeText(this, msg, Toast.LENGTH_SHORT).show();
    }
    
    // Working
    @Override
    //<!-- android:uiOptions="splitActionBarWhenNarrow": The following option will allow split Action bar, important for Portrait -->
    public boolean onCreateOptionsMenu(Menu menu) 
    {
    	// TODO Auto-generated method stub
    	super.onCreateOptionsMenu(menu);
    	// if the following doesn't exist in R.menu.actionmenu xml file then it'll be shown as normal menu with pressing menu button only
    	// the android:showAsAction="ifRoom|withText"
    	getMenuInflater().inflate(R.menu.actionmenu, menu);
    	/*getMenuInflater().inflate(R.menu.actionmenu, menu);
    	getMenuInflater().inflate(R.menu.actionmenu, menu);*/
    	return true;
    }
    
    // Working
    /*@Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) 
    {
    	// TODO Auto-generated method stub
    	Toast.makeText(this, item.getTitle(), Toast.LENGTH_SHORT).show();
    	return super.onMenuItemSelected(featureId, item);
    }*/
    
    // Working too
    @Override
    public boolean onOptionsItemSelected(MenuItem item) 
    {
    	// TODO Auto-generated method stub
    	Toast.makeText(this, item.getTitle(), Toast.LENGTH_SHORT).show();
    	return super.onOptionsItemSelected(item);
    }
}